﻿from PIL import Image

# on crée une fonction contour pour détourer une image en niveaux de gris.
# la variable sera le nom du fichier, à inscrire entre 'nomdufichier.png'
def contour(filename):
    # on ouvre l'image qu'on va détourer. Dans la suite l'image sera appelée im
    im = Image.open(filename)

    # on crée une nouvelle image dans laquelle on créera le contour de im
    im_contour = Image.new(im.mode, im.size)
    colonne, ligne = im.size
    # la double boucle for suivante va permettre de balayer les pixels de im
    for y in range(1, ligne-1):
        for x in range(1, colonne-1):
            # a, b, c et d contiennent les valeurs des pixels voisins du pixel P(x,y)
            a = im.getpixel((x-1, y-1))
            b = im.getpixel((x+1, y+1))
            c = im.getpixel((x-1, y+1))
            d = im.getpixel((x+1, y-1))

            # c'est la ligne que vous devez compléter.
            formule = (a-b)**2+(c-d)**2

            # on construit un test : si la valeur obtenue dans la formule est
            # supérieure au seuil de 2000, le pixel (x,y) fait parti du contour,
            # on le colorie en noir. Sinon, on le colorie en blanc.
            if formule > 2000:
                im_contour.putpixel((x, y), 0)
            else :
                im_contour.putpixel((x, y), 255)

    #l'instruction putpixel permet de remplacer la valeur d'un pixel(x,y)par une autre.

    im_contour.show()
    im_contour.save("Image_01.png","PNG")

